// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'pipeline.dart';

class Middleware {
  /// The http [MiddlewareClient] used by this [Middleware]
  MiddlewareClient? _client;

  String getName() => 'MiddlewareNode';

  // ignore: avoid_setters_without_getters
  set httpClient(MiddlewareClient? client) => _client = client;

  Client? get client => _client?.inner;

  Future<MiddlewareRequest> onRequest(
    MiddlewareRequest request,
  ) async {
    return request;
  }

  Future<MiddlewareResponse> onResponse(MiddlewareResponse response) async {
    return response;
  }

  @override
  String toString() {
    return getName();
  }
}
